function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_with_holes(arr) {
    if (Array.isArray(arr)) return arr;
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _async_to_generator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _iterable_to_array_limit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _non_iterable_rest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _object_spread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _define_property(target, key, source[key]);
        });
    }
    return target;
}
function _sliced_to_array(arr, i) {
    return _array_with_holes(arr) || _iterable_to_array_limit(arr, i) || _unsupported_iterable_to_array(arr, i) || _non_iterable_rest();
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
function _ts_generator(thisArg, body) {
    var f, y, t, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    }, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype), d = Object.defineProperty;
    return d(g, "next", {
        value: verb(0)
    }), d(g, "throw", {
        value: verb(1)
    }), d(g, "return", {
        value: verb(2)
    }), typeof Symbol === "function" && d(g, Symbol.iterator, {
        value: function() {
            return this;
        }
    }), g;
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(g && (g = 0, op[0] && (_ = 0)), _)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
}
import { LoadingOutlined } from "@ant-design/icons";
import { useMountMergeState } from "@ant-design/pro-components";
import { Checkbox, ConfigProvider, Dropdown, Space } from "antd";
import classNames from "clsx";
import React, { useContext, useEffect, useMemo } from "react";
import { useMEditor } from "../../../hooks/editor";
import { useEditorStore } from "../../store";
var MentionsUser = function MentionsUser(props) {
    var _editorProps_comment, _editorProps_comment1, _editorProps_comment2;
    var _React_useState = _sliced_to_array(React.useState(false), 2), loading = _React_useState[0], setLoading = _React_useState[1];
    var _React_useState1 = _sliced_to_array(React.useState([]), 2), users = _React_useState1[0], setUsers = _React_useState1[1];
    var _useMountMergeState = _sliced_to_array(useMountMergeState(props.mentions || [], {
        value: props.mentions,
        onChange: props.onSelect
    }), 2), selectedUsers = _useMountMergeState[0], setSelectedUsers = _useMountMergeState[1];
    var _useEditorStore = useEditorStore(), editorProps = _useEditorStore.editorProps, readonly = _useEditorStore.readonly;
    var onSearch = function onSearch(text) {
        return _async_to_generator(function() {
            var _editorProps_comment_loadMentions, _editorProps_comment, list;
            return _ts_generator(this, function(_state) {
                switch(_state.label){
                    case 0:
                        setLoading(true);
                        return [
                            4,
                            editorProps === null || editorProps === void 0 ? void 0 : (_editorProps_comment = editorProps.comment) === null || _editorProps_comment === void 0 ? void 0 : (_editorProps_comment_loadMentions = _editorProps_comment.loadMentions) === null || _editorProps_comment_loadMentions === void 0 ? void 0 : _editorProps_comment_loadMentions.call(_editorProps_comment, text)
                        ];
                    case 1:
                        list = _state.sent() || [];
                        setUsers(list);
                        setLoading(false);
                        return [
                            2
                        ];
                }
            });
        })();
    };
    useEffect(function() {
        onSearch('');
    }, [
        readonly
    ]);
    useEffect(function() {
        props.onSelect(selectedUsers);
    }, [
        selectedUsers
    ]);
    var mentionsPlaceholder = (editorProps === null || editorProps === void 0 ? void 0 : (_editorProps_comment = editorProps.comment) === null || _editorProps_comment === void 0 ? void 0 : _editorProps_comment.mentionsPlaceholder) || '指派给';
    return useMemo(function() {
        if (readonly) {
            return /*#__PURE__*/ React.createElement(Space, null, (selectedUsers === null || selectedUsers === void 0 ? void 0 : selectedUsers.length) ? selectedUsers === null || selectedUsers === void 0 ? void 0 : selectedUsers.map(function(u) {
                var _u_avatar;
                return /*#__PURE__*/ React.createElement("div", {
                    key: u.name,
                    style: {
                        display: 'flex',
                        alignItems: 'center',
                        backgroundColor: '#f5f5f5',
                        padding: '0 4px',
                        borderRadius: 4,
                        fontSize: '1em',
                        lineHeight: '24px',
                        color: '#1677ff'
                    }
                }, "@", ((_u_avatar = u.avatar) === null || _u_avatar === void 0 ? void 0 : _u_avatar.startsWith('http')) ? /*#__PURE__*/ React.createElement("img", {
                    width: 16,
                    height: 16,
                    src: u.avatar,
                    alt: u.name
                }) : null, /*#__PURE__*/ React.createElement("span", null, u.name));
            }) : null);
        }
        return /*#__PURE__*/ React.createElement("div", {
            onClick: function onClick(e) {
                e.stopPropagation();
                e.preventDefault();
            },
            style: {
                cursor: 'pointer'
            }
        }, /*#__PURE__*/ React.createElement(Dropdown, {
            menu: {
                items: users.map(function(u) {
                    var _u_avatar;
                    return {
                        type: 'item',
                        key: u.name,
                        label: /*#__PURE__*/ React.createElement("div", {
                            style: {
                                display: 'flex',
                                alignItems: 'center',
                                gap: 8
                            }
                        }, ((_u_avatar = u.avatar) === null || _u_avatar === void 0 ? void 0 : _u_avatar.startsWith('http')) ? /*#__PURE__*/ React.createElement("img", {
                            width: 16,
                            height: 16,
                            src: u.avatar,
                            alt: u.name
                        }) : null, /*#__PURE__*/ React.createElement("span", null, u.name)),
                        value: u.name,
                        avatar: u.avatar
                    };
                }),
                onClick: function onClick(value) {
                    setSelectedUsers(users.filter(function(u) {
                        return u.name === value.key;
                    }));
                }
            }
        }, loading ? /*#__PURE__*/ React.createElement(LoadingOutlined, {
            spin: true
        }) : /*#__PURE__*/ React.createElement(Space, null, (selectedUsers === null || selectedUsers === void 0 ? void 0 : selectedUsers.length) ? selectedUsers === null || selectedUsers === void 0 ? void 0 : selectedUsers.map(function(u) {
            var _u_avatar;
            return /*#__PURE__*/ React.createElement("div", {
                key: u.name,
                style: {
                    display: 'flex',
                    alignItems: 'center',
                    backgroundColor: '#f5f5f5',
                    padding: '0 4px',
                    borderRadius: 4,
                    fontSize: '1em',
                    lineHeight: '24px',
                    color: '#1677ff'
                }
            }, "@", ((_u_avatar = u.avatar) === null || _u_avatar === void 0 ? void 0 : _u_avatar.startsWith('http')) ? /*#__PURE__*/ React.createElement("img", {
                width: 16,
                height: 16,
                src: u.avatar,
                alt: u.name
            }) : null, /*#__PURE__*/ React.createElement("span", null, u.name));
        }) : /*#__PURE__*/ React.createElement("span", {
            style: {
                backgroundColor: '#f5f5f5',
                padding: '0 4px',
                borderRadius: 4,
                fontSize: '1em',
                display: 'inline-block',
                lineHeight: '24px',
                color: '#bfbfbf'
            }
        }, mentionsPlaceholder))));
    }, [
        editorProps === null || editorProps === void 0 ? void 0 : (_editorProps_comment1 = editorProps.comment) === null || _editorProps_comment1 === void 0 ? void 0 : _editorProps_comment1.mentionsPlaceholder,
        editorProps === null || editorProps === void 0 ? void 0 : (_editorProps_comment2 = editorProps.comment) === null || _editorProps_comment2 === void 0 ? void 0 : _editorProps_comment2.loadMentions,
        users,
        loading,
        selectedUsers,
        readonly
    ]);
};
/**
 * 列表项组件，使用 `observer` 包装以响应 MobX 状态变化。
 *
 * @param {ElementProps<ListItemNode>} props - 组件的属性。
 * @param {ListItemNode} props.element - 列表项节点元素。
 * @param {React.ReactNode} props.children - 列表项的子元素。
 * @param {object} props.attributes - 传递给列表项的其他属性。
 *
 * @returns {JSX.Element} 返回一个列表项的 JSX 元素。
 *
 * @remarks
 * - 如果 `element.checked` 是布尔值，则表示这是一个任务列表项。
 * - 使用 `useMemo` 优化渲染性能。
 * - 列表项支持拖拽操作。
 * - 如果是任务列表项，会渲染一个不可编辑的复选框。
 */ export var ListItem = function ListItem(param) {
    var element = param.element, children = param.children, attributes = param.attributes;
    var _editorProps_comment;
    var _useMEditor = _sliced_to_array(useMEditor(element), 2), update = _useMEditor[1];
    var _useEditorStore = useEditorStore(), store = _useEditorStore.store, editorProps = _useEditorStore.editorProps, markdownContainerRef = _useEditorStore.markdownContainerRef;
    var isTask = typeof element.checked === 'boolean';
    var context = useContext(ConfigProvider.ConfigContext);
    var listItemRender = editorProps === null || editorProps === void 0 ? void 0 : (_editorProps_comment = editorProps.comment) === null || _editorProps_comment === void 0 ? void 0 : _editorProps_comment.listItemRender;
    var baseCls = context.getPrefixCls('agentic-md-editor-list');
    var checkbox = React.useMemo(function() {
        if (!isTask) return null;
        return /*#__PURE__*/ React.createElement("span", {
            contentEditable: false,
            "data-check-item": true,
            className: classNames("".concat(baseCls, "-check-item"))
        }, /*#__PURE__*/ React.createElement(Checkbox, {
            checked: element.checked,
            onChange: function onChange(e) {
                update({
                    checked: e.target.checked
                });
            }
        }));
    }, [
        element.checked,
        isTask
    ]);
    var mentionsUser = React.useMemo(function() {
        if (!isTask) return null;
        return /*#__PURE__*/ React.createElement(MentionsUser, {
            onSelect: function onSelect(mentions) {
                update({
                    mentions: mentions
                });
            },
            mentions: element.mentions
        });
    }, [
        element.mentions
    ]);
    return React.useMemo(function() {
        if (listItemRender) {
            var props = {
                checkbox: checkbox,
                mentionsUser: mentionsUser,
                children: children
            };
            return /*#__PURE__*/ React.createElement("li", _object_spread({
                className: classNames("".concat(baseCls, "-item"), _define_property({}, "".concat(baseCls, "-task"), isTask)),
                "data-be": 'list-item',
                onDragStart: function onDragStart(e) {
                    store.dragStart(e, markdownContainerRef.current);
                }
            }, attributes), listItemRender(props, {
                element: element,
                children: children,
                attributes: attributes
            }));
        }
        return /*#__PURE__*/ React.createElement("li", _object_spread({
            className: classNames("".concat(baseCls, "-item"), _define_property({}, "".concat(baseCls, "-task"), isTask)),
            "data-be": 'list-item',
            onDragStart: function onDragStart(e) {
                store.dragStart(e, markdownContainerRef.current);
            }
        }, attributes), checkbox, mentionsUser, children);
    }, [
        checkbox,
        mentionsUser,
        attributes,
        element.children,
        listItemRender
    ]);
};
